"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

var _createClass = (function () { function defineProperties(target, props) { for (var key in props) { var prop = props[key]; prop.configurable = true; if (prop.value) prop.writable = true; } Object.defineProperties(target, props); } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _inherits = function (subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } };

var React = _interopRequire(require("react/addons"));

var polyfill = _interopRequire(require("babel-core/polyfill"));

var ReactIntl = _interopRequire(require("react-intl"));

var IntlDomainDatabase = require("./domaindb").IntlDomainDatabase;

// to please locale loaded later manually
window.ReactIntl = ReactIntl;

var domainsEn = {
    main: {
        photos: "{name} took {numPhotos, plural,\n                   =0 {no photos}\n                   =1 {one photo}\n                   other {# photos}\n                }"
    },
    other: {
        chicken: "The chicken's name is {name}"
    }
};

var domainsNl = {
    main: {
        photos: "{name} heeft {numPhotos, plural,\n                   =0 {geen fotos}\n                   =1 {een foto}\n                   other {# fotos gemaakt}}"
    },
    other: {
        chicken: "De naam van de kip is {name}"
    }
};

function loadDomain(localeId, domainId) {
    var messages = undefined;
    if (localeId === "en-US") {
        messages = domainsEn[domainId];
    } else if (localeId === "nl-NL") {
        messages = domainsNl[domainId];
    }
    if (messages === undefined) {
        throw new Error("Cannot load domain " + domainId + " in locale " + localeId);
    }
    return Promise.resolve(messages);
}

var db = new IntlDomainDatabase(loadDomain);

var Format = db.makeFormat("main");
var OtherFormat = db.makeFormat("other");

var Sub = (function (_React$Component) {
    function Sub() {
        _classCallCheck(this, Sub);

        if (_React$Component != null) {
            _React$Component.apply(this, arguments);
        }
    }

    _inherits(Sub, _React$Component);

    _createClass(Sub, {
        render: {
            value: function render() {
                return React.createElement(
                    "div",
                    null,
                    React.createElement(Format, { messageId: "photos",
                        name: "Bob",
                        numPhotos: 1 })
                );
            }
        }
    });

    return Sub;
})(React.Component);

var App = (function (_React$Component2) {
    function App() {
        _classCallCheck(this, App);

        if (_React$Component2 != null) {
            _React$Component2.apply(this, arguments);
        }
    }

    _inherits(App, _React$Component2);

    _createClass(App, {
        render: {
            value: function render() {
                return React.createElement(
                    "div",
                    null,
                    React.createElement(
                        "p",
                        null,
                        React.createElement(Format, { messageId: "photos",
                            name: "Annie",
                            numPhotos: 100 })
                    ),
                    React.createElement(
                        "p",
                        null,
                        React.createElement(OtherFormat, { messageId: "chicken",
                            name: "Fred" })
                    ),
                    React.createElement(
                        "p",
                        null,
                        React.createElement(Sub, null)
                    )
                );
            }
        }
    });

    return App;
})(React.Component);

document.addEventListener("DOMContentLoaded", function (event) {
    db.setLocale("nl-NL").then(function () {
        React.render(React.createElement(App, null), document.body);
    });
});